/* (C) Copyright International Business Machines Corporation 23 January  */
/* 1990.  All Rights Reserved.  */
/*   */
/* See the file USERAGREEMENT distributed with this software for full  */
/* terms and conditions of use.  */
/* Makefile for the directory /local/hermes/tools/make -- the Hermes make  */

PROCOBJS =	dcomshell.po dprintshell.po getdep.po \
		getnoncommentline.po \
		getuses.po initcheckscope.po initloadfuncs.po \
		make.po makehermes.po \
		nullaction.po pcomshell.po pprintshell.po \
		uptolow.po
PROCOBJSZ =	dcomshell.po.Z dprintshell.po.Z getdep.po.Z \
		getnoncommentline.po.Z \
		getuses.po.Z initcheckscope.po.Z initloadfuncs.po.Z \
		make.po.Z makehermes.po.Z \
		nullaction.po.Z pcomshell.po.Z pprintshell.po.Z \
		uptolow.po.Z

#include "includefile"

DEFPATH =	./defs:$(DEFDIR)

all:	compileprocs

install: all
	cp makehermes.po $(BINDIR)
	
chcode:
	$(CHCODECMD) makehermes
chcompile:
	$(CHCOMPILECMD) makehermes


/* dependencies */
dcomshell.po: dcomshell.p
dprintshell.po: dprintshell.p
getdep.po: getdep.p initloadfuncs.po initcheckscope.po getuses.po \
	pprintshell.po dprintshell.po pcomshell.po dcomshell.po \
	nullaction.po
getnoncommentline.po: getnoncommentline.p
getuses.po: getuses.p getnoncommentline.po uptolow.po
initcheckscope.po: initcheckscope.p
initloadfuncs.po: initloadfuncs.p
make.po: make.p
makehermes.po: makehermes.p getdep.po make.po
nullaction.po: nullaction.p
pcomshell.po: pcomshell.p
pprintshell.po: pprintshell.p
uptolow.po: uptolow.p


deps:
	$(BINDIR)/getdeps *.p > Makefile.deps

clean::
	rm -f $(GARBAGE) 2>/dev/null
